diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/rtl/smirtlcpp.cxx smixx/src/rtl/smirtlcpp.cxx
--- smixx_web/src/rtl/smirtlcpp.cxx	2004-11-11 14:40:56.000000000 +0100
+++ smixx/src/rtl/smirtlcpp.cxx	2007-03-19 09:55:42.000000000 +0100
@@ -10,6 +10,10 @@
 #include "smirtl.hxx"
 #include "version.h"
 
+extern "C" {
+#include "smixx_parstring_util.h"
+}
+
 static int Version_number = SMIXX_VERSION;
 
 ParInfo::ParInfo(char *name, int type)
@@ -22,13 +26,16 @@
 		case SMI_INTEGER:
 			strcpy(itsTypeStr,"(I)");
 			itsData = new char[32];
+			itsEscData =0;
 			break;
 		case SMI_FLOAT:
 			strcpy(itsTypeStr,"(F)");
 			itsData = new char[32];
+			itsEscData =0;
 			break;
 		case SMI_STRING:
 			itsData = new char[32];
+			itsEscData = new char[32];
 			strcpy(itsTypeStr,"(S)");
 			break;
 	}
@@ -38,6 +45,7 @@
 {
 	delete itsName;
 	delete itsData;
+	if ( !itsEscData ) delete itsEscData;
 }
 
 int ParInfo::setInfo(void *data, int type)
@@ -54,8 +62,16 @@
 			break;
 		case SMI_STRING:
 			delete itsData;
+			/* the user is supplying un-escaped data*/
 			itsData = new char[ strlen((char *)data) +1];
 			strcpy(itsData,(char *)data);
+			
+			/* now we have to create the escaped string*/
+			delete itsEscData;
+			int nout = smixx_escape(NULL,itsData,0);
+			if ( nout < 0 ) return -1;
+			itsEscData = new char[ nout +1];
+			smixx_escape(itsEscData, itsData,nout);
 			break;
 	}
 	return 1;
@@ -65,11 +81,30 @@
 {
 	if(itsType != type)
 		return -1;
+		
+	if ( type == SMI_STRING )
+	{
+		/* escaped string comming from command handler*/
+		delete itsEscData;
+		itsEscData = new char[ strlen(data) +1];
+		strcpy(itsEscData,(char *)data);
+		
+		/* have to unescape it*/
+		delete itsData;
+		int nout = smixx_unescape(NULL,itsEscData,0);
+		if (nout < 0) return -1;
+		itsData = new char[nout + 1];
+		nout = smixx_unescape(itsData,itsEscData,nout);
+		return 1;
+	}
+	else
+	{
 	delete itsData;
 	itsData = new char[ strlen(data) +1];
 	strcpy(itsData,(char *)data);
 	return 1;
 }
+}
 
 SmiProxy::SmiProxy(char *name)
 {
@@ -434,7 +469,7 @@
 	{
 		parname = parptr->getName();
 		len += 1 + strlen(parname) +3+1;  /* /par_name(X)= */
-		len += parptr->getDataSize();
+		len += parptr->getEscDataSize();
 		parptr = (ParInfo *)itsParList.getNext();
 	}
 	len += 1;
@@ -460,7 +495,7 @@
 		strcat(itsState, parptr->getName());
 		strcat(itsState, parptr->getTypeStr());
 		strcat(itsState,"=");
-		strcat(itsState, parptr->getData());
+		strcat(itsState, parptr->getEscData());
 		parptr = (ParInfo *)itsParList.getNext();
 	}
 }
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/rtl/smiuirtl.c smixx/src/rtl/smiuirtl.c
--- smixx_web/src/rtl/smiuirtl.c	2005-08-09 19:06:56.000000000 +0200
+++ smixx/src/rtl/smiuirtl.c	2007-03-19 09:55:42.000000000 +0100
@@ -14,6 +14,9 @@
 
 #include <stdlib.h>
 #include <string.h>
+
+#include "smixx_parstring_util.h"
+
 /*
 #include "parameters.h"
 */
@@ -1485,9 +1488,7 @@
 				get_token(ptr,&aux_ptr);
 				if(*type == SMI_STRING)
 				{
-					*size = strlen(aux_ptr);
-					if(aux_ptr[0] == '"')
-						*size -=2;
+					*size = smixx_unescape(NULL,aux_ptr,0);
 				}
 				else if(*type == SMI_INTEGER)
 				{
@@ -1540,6 +1541,7 @@
 {
 	char *aux_ptr;
 	int type, ret = 0;
+	int nout;
 
 	type = SMI_STRING;
 	push_token(ptr);
@@ -1560,13 +1562,8 @@
 		switch(type)
 		{
 			case SMI_STRING:
-				if(aux_ptr[0] == '"')
-				{
-					aux_ptr[strlen(aux_ptr) - 1] = '\0'; 
-					strcpy(val, aux_ptr + 1);
-				}
-				else
-					strcpy(val, aux_ptr);
+				nout = smixx_unescape(NULL,aux_ptr,0);
+				nout = smixx_unescape(val,aux_ptr,nout);
 				break;
 			case SMI_INTEGER:
 				if(strchr(aux_ptr,'x'))
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/rtl/smiuirtlcpp.cxx smixx/src/rtl/smiuirtlcpp.cxx
--- smixx_web/src/rtl/smiuirtlcpp.cxx	2005-08-09 17:43:48.000000000 +0200
+++ smixx/src/rtl/smiuirtlcpp.cxx	2007-03-19 09:55:42.000000000 +0100
@@ -8,6 +8,10 @@
 #define SMIUILIB
 #include "smiuirtl.hxx"
 
+extern "C" {
+#include "smixx_parstring_util.h"
+}
+
 static void obj_change_rout(int *objId, SmiObject **tag)
 {
 	SmiObject *t = *tag;
@@ -100,6 +104,7 @@
 	itsDefault = 0;
 	itisObj = 0;
 	itsValueSize = 0;
+	itsEscValueSize = 0;
 }
 
 SmiParam::~SmiParam() 
@@ -107,6 +112,8 @@
 	delete itsName;
 	if(itsValueSize)
 		delete (char *)itsValue;
+	if(itsEscValueSize)
+		delete (char *)itsEscValue;
 }
 
 int SmiParam::setValue(int val) 
@@ -151,9 +158,36 @@
 		itsValueSize = strlen(val)+1;
 	} 
 	strcpy((char *)itsValue, val);
+	/* now the escaped value */
+	if ( itsEscValueSize ) delete (char *) itsEscValue;
+	int nout = smixx_escape(NULL,val,0);
+	if (nout < 0) return -1;
+	itsEscValue = new char[nout+1];
+	nout = smixx_escape((char* )itsEscValue,val,nout);
+	itsEscValueSize = nout + 1;
+	
 	return(1);
 }
 
+void SmiParam::convertToEsc()
+{
+	if ( itsType != SMI_STRING ) return;
+	
+	if ( itsEscValueSize ) delete (char *) itsEscValue;
+	int nout = smixx_escape(NULL,(char *)itsValue,0);
+	if (nout < 0) return ;
+	itsEscValue = new char[nout+1];
+	nout = smixx_escape((char* )itsEscValue,(char *)itsValue,nout);
+	itsEscValueSize = nout + 1;
+	
+	return;
+}
+
+SmiParam *ParamHandler::getFirstParam() 
+{
+	return (SmiParam *)itsParamList.getHead(); 
+}
+
 SmiParam *ParamHandler::getNextParam() 
 {
 	return (SmiParam *)itsParamList.getNext(); 
@@ -204,6 +238,8 @@
 				paramptr->itsValue); 
 			if(ret)
 				paramptr->itsDefault = 1;
+			if(ret)
+				paramptr->convertToEsc();
 		}
 		addParam(paramptr);
 	}
@@ -278,7 +314,8 @@
 	if(getNParams())
 	{
 		SmiParam *param;
-		while(param = getNextParam())
+		param = getFirstParam();
+		while (param)
 		{
 			if(!param->itsValueSize)
 			{
@@ -297,11 +334,12 @@
 						sprintf(tmp,"/%s(F)=%e",param->itsName, *(double *)param->itsValue);
 						break;
 					case SMI_STRING:
-						sprintf(tmp,"/%s=\"%s\"",param->itsName, (char *)param->itsValue);
+						sprintf(tmp,"/%s=\"%s\"",param->itsName, (char *)param->itsEscValue);
 						break;
 				}
 			}
 			strcat(cmnd, tmp);
+			param = getNextParam();
 		}
 	}
 	smiui_send_command(itsObject->getName(),cmnd);
@@ -502,6 +540,8 @@
 		int ret = smiui_get_obj_param_value(id, paramptr->itsValue); 
 		if(ret)
 			paramptr->itsDefault = 1;	
+		if(ret)
+			paramptr->convertToEsc();	
 		addParam(paramptr);
 	}
 }
@@ -998,7 +1038,7 @@
 				os <<"=" << par.getValueFloat();
 				break;
 			case SMI_STRING:
-				os <<"=" << par.getValueString();
+				os <<"=" << par.getEscValueString();
 				break;
 		}
 	}
Binary files smixx_web/src/src/examples/run_control/bin/evt_builder.exe and smixx/src/src/examples/run_control/bin/evt_builder.exe differ
Binary files smixx_web/src/src/examples/run_control/bin/evt_builder.ilk and smixx/src/src/examples/run_control/bin/evt_builder.ilk differ
Binary files smixx_web/src/src/examples/run_control/bin/evt_builder.pdb and smixx/src/src/examples/run_control/bin/evt_builder.pdb differ
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/History smixx/src/stateManager/History
--- smixx_web/src/stateManager/History	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/History	2007-03-19 09:55:42.000000000 +0100
@@ -1887,3 +1887,177 @@
    
 === 11-Jul-2005:15:00 ========= v27r1-sm9 ====================================	  
 === 14-July-2005:17:07 ==========  v28  =================
+
+  15-Aug-2005 (Clara Gaspar)
+  
+    commhandler.*  ... bug fix
+    
+  28-Sep-2005  (Boda Franek)
+  
+  scheduler.cxx, doins.cxx insertins.cxx ... some prints suspended for dbg < 3
+  
+=== 28-September-2005:15:35 ==========  v28r1  =================
+
+  28-Sep-2005 (Boda Franek)
+  
+   - termins.* class TermIns ...  private _endState changed from char string type to Name
+   
+  - End State of an instruction will be returned as type Name rather then char string
+   ---------------------------------------------------------------------------------
+   The reason is that if it is returned as a string a fixed space has to be reserved
+   for it.
+   The class Instruction (instruction.hxx) has the declaration of execute method changed.
+   Because all the instructions inherit from it they all have to change this declaration
+   even if they do not set the endstate. These are: DoIns (doins.*), InsertIns (insertins.*)
+   and SetIns (setins.*).
+   TermIns (termins.*)  and IfIns (ifins.*) are the only instructions that can end in a new
+   state and require some mods.
+   At this stage I decided to return string from InsList (inslist.*) as before. However
+   the class now has to take into account that the instructions are returning Name.
+   
+=== 28-September-2005:17:40 ==========  v28r1-sm1  =================
+   
+  29-Sep-2005 (Boda Franek)
+  
+  - End State of an instruction list will be returned as type Name rather then char string
+   ---------------------------------------------------------------------------------------
+   Instruction list (class InsList) is used by IfIns class and Action class. Therefore
+   changes to inslist.*, ifins.cxx and action.cxx
+   
+=== 29-September-2005:15:25 ==========  v28r1-sm2  =================   
+
+  30-Sep-2005 (Boda Franek)
+  
+  - End State of an action will be returned as type Name rather then char string
+   -----------------------------------------------------------------------------
+   
+   Action class is used by State class. Therefore changes to action.* & state.cxx
+   
+=== 30-September-2005:13:55 ==========  v28r1-sm3  =================      
+  
+  - End State of a state will be returned as type Name rather then char string
+   -----------------------------------------------------------------------------
+          This is the end of End State saga
+	     
+   State class is used by SMIObject class. Therefore changes to state.* & smiobject.cxx
+   
+=== 30-September-2005:14:25 ==========  v28r1-sm4  =================      
+
+   - removing the remaining usage of MAXNAMESIZE parameter
+     -----------------------------------------------------
+    action.* ... the method name which uses MAXNAMESIZE is not used by anybody
+              and therefore deleted
+	      
+    commhandler.cxx ... MAXNAMESIZE used in commented-out section of the code
+             this section was therefore deleted.
+	     
+    smiclassregistrar.* removed. The class was made obsolete. See 11-Jul-2005
+    
+    smiobject.cxx ...the main change is removal of an obsolete method
+            subobjectName(int, char*)     
+
+    action.*  constructor returns action name as Name type rather than char
+              string.
+
+    state.cxx ... takes the above into account
+                  obsolete method action(int, char*) removed
+		  
+    parameters.hxx MAXNAMESIZE removed
+    
+=== 30-September-2005:16:10 ==========  v28r1-sm5  =================   
+
+   4-Oct-2005 (Boda Franek)
+   Removing remaing 'fixed' declarations
+   -------------------------------------
+   I have ran the following command:
+   
+   grep '\[.*\] *[\[,;]' * > badDeclarationx.txt
+   
+   and visualy inspected the result. The following files were identified as
+   containing bad declarations:
+   
+   action.cxx, condition.cxx, condition.hxx, doins.cxx,
+   ifhandler.hxx, initiator.cxx, ifins.hxx, setins.cxx,
+   smiclass.cxx, smiobject.cxx & state.cxx
+   The offending lines in badDeclarations.txt are marked by *- at the begining
+   
+   NB I have ignored declarations with well defined fixed
+      size such as char type[7]
+   
+   5-Oct-2005 (Boda Franek)
+   
+   ifins.*  private data InsList *_pblocks[100]; Condition *_pCondition[100]
+            replaced by PtrVector _insLists; PtrVector _conditions;
+    
+=== 05-October-2005:12:10 ==========  v28r1-sm6  ================= 	  
+=== 06-October-2005:15:38 ==========  v29  =================
+
+ 11-Jan-2006 (Boda Franek)
+    Removed the limitations on the number of Instruction Blocks of an action
+    ------------------------------------------------------------------------
+    ifIns.hxx, ifIns.cxx ... 
+          1) Argument InsList** pAllBlocks replaced by PtrVector& allBlocks
+	  2) argument int *no_lines replaced by int& no_lines
+	  3) whatAreYou method improved
+
+    inslist.hxx & cxx ...
+          1) Argument InsList** pblocks replaced by PtrVector& allBlocks
+	  2) argument int *no_lines replaced by int& no_lines	  
+    
+    action.cxx ...
+          InsList *pblocks[maxInsBlocks]   replaced by PtrVector allBlocks
+=== 11-January-2006:14:10 =========== v29-sm1===============================
+
+ 12-Jan-2006 (Boda Franek)
+    condition.hxx & cxx ...
+        SmpCond* _pSmpCond[_maxSmpCond]    replaced by PtrVector _smpConditions;
+=== 20-January-2006:11:40 =========== v29-sm2===============================	
+
+ 20-Jan-2006 (Boda Franek)	
+	 
+    condition.hxx & cxx
+      Internal int smpflags[_maxSmpCond]  replaced by
+               vector<int> smpflags;
+	       
+=== 20-January-2006:14:46 ==========  v29r1  =================
+
+ 31-Mar-2006  (Boda Franek)
+ 
+   smiobject.hxx & cxx  new method : bool hasAssociatedAttribute() const
+   
+   smiobject.cxx  ... ASSOCIATED attribute for is_of_class is taken only from
+                      the class
+
+   state_manager.cxx ... some debug prints added and are commented out
+=== 31-March-2006:17:27 ==========  v30  =================
+
+ 19-May-2006  (Boda Franek)
+ 
+  - Changes to IfHandler class
+    --------------------------
+     a) private data
+        Name int _numOfObjects; _objNames[100];  SetName* _pTobeLocked[100]; replaced by
+        NmdPtnrList _suspendedObjects; holding the same info
+
+     b) 2 new private methods
+        int findRequester     and  int findFreeToResumeObject
+	
+     c) method bool isEmpty() removed as it is not used by anyone
+   
+     d) arguments of public method addSet    and    objectLocked  rationalised
+   
+     Files affected: ifhandler.hxx, ifhandler.cxx,  ifins.cxx and smiobject.cxx
+   
+  - state.cxx   eliminated the usage of temporary string char actionstr_out[256]
+  
+  This concludes the dynamisation campaign that started some time ago. There are two
+  outstanding things that should get attention some time in future:
+       1) the finate dimension of the input record and the associated MAXRECL parameter
+       2) initiator should be probably redesigned.
+       
+=== 19-May-2006:20:34 ==========  v31  =================
+  21-May-2006 (Boda Franek)
+  
+     ifhandler.cxx .. various diagnostic prints conditioned on dbg> 5
+     
+=== 21-May-2006:21:01 ==========  v31r1  =================
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/action.cxx smixx/src/stateManager/action.cxx
--- smixx_web/src/stateManager/action.cxx	2004-11-11 14:40:56.000000000 +0100
+++ smixx/src/stateManager/action.cxx	2006-01-11 14:55:47.000000000 +0100
@@ -15,7 +15,7 @@
 //-----------------------------------------------------------------------------
 
 Action::Action
-      ( char lines[][MAXRECL],char* action_nm,int *no_lines, 
+      ( char lines[][MAXRECL],Name& action_nm,int *no_lines, 
         SMIObject *pobj, State* pstat){
 //
 // First, the Action class is instantiated and as a part of its initialisation,
@@ -23,18 +23,16 @@
 // may contain many blocks, it points directly only to this block (0).
 // The other blocks of the action are accessed hirachically from block(0)
 
-   enum { maxInsBlocks = 500 };     // maximal number of Instruction blocks
-                                    // of the current action
-
    int NoOfBlocks;
-   InsList *pblocks[maxInsBlocks];  // pointers to all the blocks 
+   PtrVector allBlocks;  // pointers to all the blocks 
                                     // of the current action
+    InsList* pblock;
 
    _objName = pobj->name();
    _pParentObject = pobj;
    _pParentState = pstat;
 
-   strcpy(action_nm,lines[1]);
+   action_nm = lines[1];
 
    _actionName = action_nm; 
 
@@ -111,10 +109,11 @@
 //           << endl;
       assert ( curr_block == NoOfBlocks );
 
-      pblocks[curr_block] = new InsList
+      
+      pblock = new InsList
           (curr_block,curr_level,_pParentObject,_pParentState,this);
-      assert( pblocks[curr_block] != 0 );
-      assert ( NoOfBlocks < maxInsBlocks );
+      assert( pblock != 0 );
+      allBlocks+= pblock;
       NoOfBlocks++;
     }
   }
@@ -125,12 +124,13 @@
       _pblock = 0;
    }
    else {
-      _pblock = pblocks[0];
+      _pblock = static_cast<InsList*>(allBlocks[0]);
    }
 
 
 //---------------------- Loop over the action lines ---------------------------
 
+//cout << endl << _actionName << endl;
   int blkno;
   blkno = 0;
 
@@ -141,7 +141,10 @@
     }
     else if (!strcmp(lines[il],"*BLOCK")) {
       int no_blklines;
-      pblocks[blkno]->initialise(&lines[il],pblocks,&no_blklines);
+      pblock = static_cast<InsList*>(allBlocks[blkno]);
+      pblock->initialise(&lines[il],allBlocks,no_blklines);
+//      cout << endl << "Block : " << blkno << "  " << pblock  << endl;
+//      pblock->listInstructions();
       blkno++;
       il = il + no_blklines -1;
     }
@@ -173,7 +176,7 @@
 
 
 //--------------------------------  execute  -----------------------------------
-int Action::execute(char* pstate, const Name& actionstr) {
+int Action::execute( Name& endState, const Name& actionstr) {
 //
 
 #ifdef DEBUG
@@ -224,10 +227,10 @@
 //-----------------------------------------
 
   int temp;
-  char state[MAXNAMESIZE];
+  
   if (_pblock == 0) { return 0;}   // some crazy guys have no instructions
-  temp = _pblock->execute(state);
-  strcpy(pstate,state);
+  temp = _pblock->execute(endState);
+  
 
   return temp;
 }
@@ -245,16 +248,6 @@
 Parms* Action::pDeclaredParms() {
    return &_declaredParms;
 }
-
-//---------------------------- name ----------------------------------------
-void Action::name ( char* name, int* numParam) {
-   _actionName.whatAreYou(name,MAXNAMESIZE);
-//
-   *numParam = _declaredParms.numOfEntries();
-//
-   return;
-}
-
 //---------------------------- actionString -------------------------------
 //  action/par1/par2=/par3
 //
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/action.hxx smixx/src/stateManager/action.hxx
--- smixx_web/src/stateManager/action.hxx	2004-05-26 17:23:28.000000000 +0200
+++ smixx/src/stateManager/action.hxx	2005-09-30 16:51:08.000000000 +0200
@@ -16,16 +16,14 @@
 class Action {
 public :
   Action
-    ( char lines[][MAXRECL],char* action_nm,int *no_lines,
+    ( char lines[][MAXRECL],Name& action_nm,int *no_lines,
       SMIObject *pobj, State* pstat);
 
   void whatAreYou();
 
-  void name(char* name, int *numParameters);
-
   void actionString(Name& actionstr);
 
-  int execute(char* pstate, const Name& actionstr) ;
+  int execute(Name& endState, const Name& actionstr) ;
 
   Parms* pCurrentParameters() ; // returns the pointer to the current parms
 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/commhandler.cxx smixx/src/stateManager/commhandler.cxx
--- smixx_web/src/stateManager/commhandler.cxx	2005-05-31 14:50:26.000000000 +0200
+++ smixx/src/stateManager/commhandler.cxx	2005-09-30 15:49:56.000000000 +0200
@@ -615,38 +615,7 @@
 void CommHandler::declareObjList()
 {
 	char tmpstr[MAX_NAME];
-/*
-	int nsub;
-	Obj *objptr;
-	int size;
-	int index = 0;
-
-	size = nObjs*MAXNAMESIZE;
 
-	itsObjList = (char *)new char[size];
-	memset(itsObjList,0,size);
-
-	for(int i = 0; i < itsObjs.length(); i++)
-	{
-		objptr = (Obj *)itsObjs[i];
-		if((nsub = objptr->getNSubObjs()) > 1)
-		{
-			for(int j=0; j<nsub; j++)
-			{
-				strcpy(tmpstr,objptr->getName().getString());
-				strcat(tmpstr,".");
-				strcat(tmpstr,
-					objptr->getSubObj(j)->getName().getString());
-				strcpy(&itsObjList[(index++)*MAXNAMESIZE], tmpstr); 
-			}
-		}
-		else
-		{
-			strcpy(tmpstr,objptr->getName().getString());
-			strcpy(&itsObjList[(index++)*MAXNAMESIZE], tmpstr); 
-		}
-	}
-*/
     itsVersion = SMIXX_VERSION;
 	strcpy(tmpstr,"SMI/");
 	strcat(tmpstr,CommHandler::domainName);
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/condition.cxx smixx/src/stateManager/condition.cxx
--- smixx_web/src/stateManager/condition.cxx	2004-11-11 14:40:56.000000000 +0100
+++ smixx/src/stateManager/condition.cxx	2006-01-20 14:41:59.000000000 +0100
@@ -3,6 +3,8 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <assert.h>
+#include <vector>
+using namespace std;
 #include "namelist.hxx"
 #include "condition.hxx"
 #include "smpcondtyp1.hxx"
@@ -36,7 +38,6 @@
    il++;
    sscanf(lines[il],"%d %d",&_noOfSmpCond,&_noOfCondIns);
    assert (_noOfSmpCond >= 0);
-   assert (_noOfSmpCond < _maxSmpCond); 
 
    assert (_noOfCondIns >= 0);
    assert (_noOfCondIns < _maxCondIns); 
@@ -44,6 +45,7 @@
    il++;
 
 	Name objNm; Name setNm;
+	SmpCond* pSmpCond;
 
 	if ( _noOfSmpCond > 0 ) {
 		int typ; SmpCondTyp1* pType1; SmpCondTyp2* pType2;
@@ -55,20 +57,20 @@
 			sscanf(lines[il],"%d",&typ);
 			if (typ == 1) {
 	 			pType1 = new SmpCondTyp1(&lines[il],no_smpcond_lines);
-				_pSmpCond[ismp] = pType1;
+				pSmpCond = pType1;
 			}
 			else if (typ == 2) {
 	 			pType2 = new SmpCondTyp2(&lines[il],no_smpcond_lines);
-				_pSmpCond[ismp] = pType2;
+				pSmpCond = pType2;
 			}
 			else {
 	 		cout << " illegal simple instructionb type " << endl;
 			exit(1);
 			}
-
+                        _smpConditions += pSmpCond;
 			il = il + no_smpcond_lines;
-			_srvOList.exclusiveUpdate(_pSmpCond[ismp]->refObjects());
-			_srvOSList.exclusiveUpdate(_pSmpCond[ismp]->refObjectSets());
+			_srvOList.exclusiveUpdate(pSmpCond->refObjects());
+			_srvOSList.exclusiveUpdate(pSmpCond->refObjectSets());
 		}
 		
 	}
@@ -102,8 +104,10 @@
 
 // The following is just a test of simple condition function
 //   if ( _noOfSmpCond > 0 ) {
+//      cout << endl ;
 //      for (int ismp=0; ismp < _noOfSmpCond; ismp++) {
-//	 cout << (_pSmpCond[ismp]->whatAreYou()).getString() << "\n";
+//          pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+//	 cout << (pSmpCond->whatAreYou()).getString() << "\n";
 //      }
 //   }
 
@@ -111,7 +115,7 @@
   return ;
 }  
 
-
+//=================================================================================
 void Condition::whatAreYou(int maxStrLen, char* condString) {
 //   cout << " Condition::whatAreYou   not implemented yet \n";
    strcpy(condString,_condition);
@@ -121,10 +125,12 @@
 //---------------------------- evaluate -----------------------------------
 int Condition::evaluate() {
 //
+    SmpCond* pSmpCond;
    int flag;
    int ismp;
    int icins;
-   int smpflags[_maxSmpCond];     
+   vector<int> smpflags;
+   int smpflag;     
    int X[_maxCondIns];
 	int allGhosts = 1;
 //
@@ -142,15 +148,17 @@
 #ifdef DEBUG
          cout << "    T" << ismp+1 << ": " << endl;
 #endif
-         smpflags[ismp] = _pSmpCond[ismp]->evaluate();
+         pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+         smpflag = pSmpCond->evaluate();
+	 smpflags.push_back(smpflag);
 #ifdef DEBUG
 	cout << " evaluates to " << smpflags[ismp] << endl;
 #endif
-         if (smpflags[ismp] == -1 ) { 
+         if (smpflag == -1 ) { 
              flag = -1;
              goto Fin;
          }
-	 if (smpflags[ismp] != -2 ) {allGhosts = 0;} 
+	 if (smpflag != -2 ) {allGhosts = 0;} 
    }
 //
    if (allGhosts == 1) {
@@ -247,9 +255,11 @@
 bool Condition::isPresent( const char *objName) const {
 //
    Name tmpName = objName;
+   SmpCond* pSmpCond;
    
    for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
-         if ( _pSmpCond[ismp]->isPresent(tmpName) ) { return 1; }
+         pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+         if ( pSmpCond->isPresent(tmpName) ) { return 1; }
    }
 //
    return 0;
@@ -348,6 +358,7 @@
 //--------------------------  objectSet   ------------------------
 void Condition::objectSet(Set_Name *pobjSet) {
 //
+    SmpCond* pSmpCond;
 
    if ( !pobjSet->isEmpty() ) {
         cout << " objectSet   is not empty\n";
@@ -359,7 +370,8 @@
    NameList list; Name name;
 
    for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
-	_pSmpCond[ismp]->objectsToLock(list);
+        pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+	pSmpCond->objectsToLock(list);
 	list.reset();
 	while (list.nextItem(name)) {
 		pobjSet->add(name.getString());
@@ -371,10 +383,12 @@
 //--------------------------  addto_objectSet   ------------------------
 void Condition::addto_objectSet(Set_Name *pobjSet) {
 //
+    SmpCond* pSmpCond;
    NameList list; Name name;
 
    for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
-	_pSmpCond[ismp]->objectsToLock(list);
+        pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+	pSmpCond->objectsToLock(list);
 	list.reset();
 	while (list.nextItem(name)) {
 		pobjSet->add(name.getString());
@@ -383,15 +397,21 @@
 }
 //------------------------------------------------------------------
 void Condition::freeze() {
+    SmpCond* pSmpCond;
+    
 	for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
-		_pSmpCond[ismp]->freeze();	
+	        pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+		pSmpCond->freeze();	
 	}
 	return;	
 }
 //------------------------------------------------------------------
 void Condition::unfreeze() {
+    SmpCond* pSmpCond;
+    
 	for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
-		_pSmpCond[ismp]->unfreeze();	
+	        pSmpCond = static_cast<SmpCond*>(_smpConditions[ismp]);
+		pSmpCond->unfreeze();	
 	}
 	return;	
 }
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/condition.hxx smixx/src/stateManager/condition.hxx
--- smixx_web/src/stateManager/condition.hxx	2002-01-29 19:09:12.000000000 +0100
+++ smixx/src/stateManager/condition.hxx	2006-01-20 14:41:59.000000000 +0100
@@ -6,6 +6,7 @@
 #include "smpcond.hxx"
 #include "set_name.hxx"
 #include "namevector.hxx"
+#include "ptrvector.hxx"
 class  SmpCond;
 //                                                         B. Franek
 //                                                         09-Aug-1996
@@ -52,8 +53,7 @@
    int _noOfSmpCond;    // Number of simple conditions
    int _noOfCondIns;    // Number of condition instructions
 
-   enum { _maxSmpCond = 100 };
-   SmpCond *_pSmpCond[_maxSmpCond];  // Pointers to simple conditions
+   PtrVector _smpConditions;  // Pointers to simple conditions
 
    enum { _maxCondIns = 100 };
    char _condIns[_maxCondIns+1][MAXRECL];  // Condition Instruction lines
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/doins.cxx smixx/src/stateManager/doins.cxx
--- smixx_web/src/stateManager/doins.cxx	2005-08-15 17:29:08.000000000 +0200
+++ smixx/src/stateManager/doins.cxx	2005-09-28 18:41:09.000000000 +0200
@@ -9,6 +9,7 @@
    extern  Name smiDomain;
 #include "registrar.hxx"
    extern Registrar allSMIObjectSets;
+   extern int dbg;
 //-------------------------------------------------
 #include "doins.hxx"
 #include "smiobjectset.hxx"
@@ -94,7 +95,7 @@
 //----------------------------  execute  ---------------------------------------
 //
 //
-int DoIns::execute(char* pendState){
+int DoIns::execute( Name& endState ){
 //
 //
 #ifdef DEBUG
@@ -182,8 +183,10 @@
 		if(!pCurPars  || !pCurPars->get(parName,parVal,type)) {
 			cout << " No value for parameter " << parName << endl;
 		}
-//CG		cout << " Parameter " << parName 
-//		<< " has value " << parVal << endl;
+		if ( dbg > 2 ) {
+        	    cout << " Parameter " << parName 
+                    << " has value " << parVal << endl;
+		}
 		char* parValchr = parVal.getString(); 
 		parValchr[strlen(parValchr)-1] = '\0';
 		Name objNm = &parValchr[1];
@@ -203,7 +206,7 @@
 
 
 
-   strcpy(pendState,"not changed");
+   endState = "not changed";
    return 0;         // do instruction allways finishes
 }
 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/doins.hxx smixx/src/stateManager/doins.hxx
--- smixx_web/src/stateManager/doins.hxx	2004-05-26 17:28:08.000000000 +0200
+++ smixx/src/stateManager/doins.hxx	2005-09-28 18:41:09.000000000 +0200
@@ -21,7 +21,7 @@
  ( char lines[][MAXRECL], int lev,int *no_lines, 
   SMIObject *pobj=0, State *pstat=0, Action* act=0);
   void whatAreYou();
-  int execute(char* pstate);   // 0-normal,  1-terminated action, 2-suspended
+  int execute( Name& endState );   // 0-normal,  1-terminated action, 2-suspended
 
   void executeHp();
 private:
